/*
    author:liumin
    email:liuming01@xz-soft.com
    description:构建消息模块模块
    create:2015.06.01
    update:2015.06.25
*/
appcan.define("Interaction", function($, exports, module) {
       var Interaction ={
           //公共aja接口           
            Ajax : function(urls, types, datas, dataTypes, successCallback,errorCallback, completeCallback, isShowLoader) {
                var me = this;
                var loader = null;
                var meUrls = urls;
                $.ajax({
                    url : urls,
                    type : types,
                    data : datas,
                    async:true,
                    contenttype: "application/json; charset=gbk", 
                    dataType :dataTypes,
                    timeout : 20 * 1000,
                    beforeSend : function(xhr, settings) {
                        if (isShowLoader !== false) {
                            //load(20000);
                        }
                    },
                    success : function(data, textStatus, jqXHR) {
                        appcan.window.closeToast();
                        if (successCallback) {
                            successCallback(data, textStatus, jqXHR);
                        }
                    },
                    error : function(xhr, textStatus, errorThrown) {
                        if (errorCallback) {
                            errorCallback(xhr, textStatus, errorThrown);
                        }
                        if (textStatus == "timeout") {
                            //toast("服务器连接失败",3,2000);
                        } else {
                          // toast("服务器连接失败",3,2000);
                        }
                    },
                    complete : function(xhr, status) {
                        if (isShowLoader !== false) {
                            //removeLoad();
                        }
                        if (completeCallback && completeCallback()) {
                            completeCallback(xhr, status);
                        }
                    }
                });
            },//超出文本检查
            imgShow:function(e,index){
                
                e.stopPropagation();
                 var arrImg = [];
                 $($("#"+index).find("img")).each(function(){
                     var path = appcan.constants.DOWN_IMG+"file_id="+$(this).attr("data-src")+"&org_id="+user.org_id;
                    arrImg.push(path);
                 })
                 var imgLoc={
                     "index":$(e.currentTarget).index(),
                     "arrImg":arrImg
                 }
                 setLocJson("imgShow",imgLoc);
                 //把所有的图片都捞出来
                 uexImageBrowser.open(arrImg,$(e.currentTarget).index());
                //appcan.window.open("imgShow","../message_content/img_show.html",5);
            },
            //时间显示
            dateShow:function(targetDate,sysDate){
                var  thatDate =targetDate.split(" ");
                var sysDate_string="";
                if(sysDate){
                    sysDate_string = sysDate.replace(/-/g,"/");
                }
               if(GetDateStr(-1)===thatDate[0]){
                   console.info("昨天");
                   return "昨天 "+thatDate[1]
               }else if(GetDateStr(0)==thatDate[0]){
                   console.info("今天");
                    return "今天 "+thatDate[1]
               }else{
                   return targetDate;
               }
                function GetDateStr(AddDayCount){
                    if(sysDate_string){
                        var dd =new Date(sysDate_string);
                    }else{
                        var dd =new Date();
                    }
                    dd.setDate(dd.getDate()+AddDayCount);
                    var y = dd.getFullYear();
                    var m = dd.getMonth()+1;
                    if(m<10){
                        m = "0"+m;
                    }
                    var d = dd.getDate();
                    if(d<10){
                        d = "0"+d;
                    }
                    return y+"-"+m+"-"+d;
                }
            },closeToast:function(msg,callfunctionOne,callfunctionTwo){
                uexWindow.cbConfirm = function(opId, dataType, data) {
                    //调用对话框提示函数
                    if (data == 0) {
                        callfunctionOne && callfunctionOne();
                            //用户点击稍后按钮，不进行更新
                    } else {
                        if(callfunctionTwo){
                            callfunctionTwo()
                        }else{
                            appcan.window.close(-1);
                        }
                        
                    }
                }
                if(!msg){
                    msg= '当前数据没有保存，是否关闭'
                }
                var value = "取消;确定";
                var mycars = value.split(";");
                uexWindow.confirm('',msg, mycars);
            },
            popup:function(d_html,duration){
                var m = document.getElementById('popup_div');
                    if(m!=null){return}
                    
                    if(duration==0){duration=1000000}
                    duration=isNaN(duration)?3000:duration;
                    var m = document.createElement('div');
                    m.id="popup_div";
                    m.innerHTML = '<div  class="cube-loader" style="background-color: rgb(102, 102, 102);"></div>'+d_html;
                    m.style.cssText="background-color:#666666"
                   document.body.appendChild(m);
                    setTimeout(function() {
                        var d = 0.5;
                        m.style.webkitTransition = '-webkit-transform ' + d + 's ease-in, opacity ' + d + 's ease-in';
                        m.style.opacity = '0';
                        setTimeout(function() { document.body.removeChild(m) }, d * 1000);
                    }, duration);
            },
            removePopup:function(duration){
                var m = document.getElementById('popup_div');
                setTimeout(function() {
                    var d = 0.5;
                    m.style.webkitTransition = '-webkit-transform ' + d + 's ease-in, opacity ' + d + 's ease-in';
                    m.style.opacity = '0';
                    setTimeout(function() { document.body.removeChild(m) }, d * 1000);
                }, duration);
            }
       };
       
    module.exports = Interaction;
});